#include <stdio.h>
#include <SDL/SDL.h>

#include "ogl.h"
#include "scene.h"
#include "timer.h"
#include "text.h"


bool Quit=false; //ja Quit=true - laiks iziet no programmas
bool Keys[512]; //masiivs, kuraa glabaasim pogu staavokljus

extern int RenderMode; //ar kaadu panjeemienu rendereet


int main(int argc,char *argv[])
{
    for(int i=0;i<512;i++)//saakumaa visas pogas uzstaadas
        Keys[i]=false;   //kaa nenospiestas 
    
    printf("Meegjinu inicializeet SDL...\n");
    if(SDL_Init(SDL_INIT_VIDEO | SDL_INIT_TIMER)==-1)//iesleedzam SDL ar video un taimeri
    {
        printf("Neizdevaas: %s\n",SDL_GetError());
        return -1;
    }
    printf("SDL inicializeets.\n");
    
    int Width=800; //ekraana platums
    int Height=600; //garums
    ScreenWidth=Width;
    ScreenHeight=Height;
    
    int Bpp=32; //cik biti uz pikseli
    int Flags=SDL_OPENGL; //pieprasiisim log uar OpenGL atbalstu
    // Flags|=SDL_FULLSCREEN; //ja gribam, varam iesleegt fullscreen
                    
                    
    SDL_Event Event; //mainiigais, ar kuru SDL mums var suutiit kaadu zinju
    
    SDL_GL_SetAttribute( SDL_GL_RED_SIZE, 8 ); //pieprasam vismaz 8 bitus sarkanajai kraasai
    SDL_GL_SetAttribute( SDL_GL_GREEN_SIZE, 8 ); //taapat zaljajai
    SDL_GL_SetAttribute( SDL_GL_BLUE_SIZE, 8 ); //un zilajai
    SDL_GL_SetAttribute( SDL_GL_ALPHA_SIZE, 8 ); //un alpha kanaalam
    SDL_GL_SetAttribute( SDL_GL_DEPTH_SIZE, 32 ); //pieprasam 32 bitu Z bufferi
    SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 ); //pieprasam dubulto buferi - vienu ziimeeshanai
                                                   //otru - raadiishanai
    
    if(SDL_SetVideoMode(Width,Height,Bpp,Flags)==0) //meegjinam uztaisiit logu ar
    {                                               //noraadiitajaam iipashiibaam 
        printf("Neizdevaas iesleegt video modi: %s\n",SDL_GetError());
        SDL_Quit();
        return -1;                                               
    }
    
    SDL_WM_SetCaption("OpenGL Tutorial","..."); //samainam loga nosaukumu un "ikonas nosaukumu???"
    SDL_ShowCursor(0); //nosleepjam peles kursoru
    
    if(!InitOpenGL(Width,Height)) //inicializeejam dazus OpenGL mainiigos
    {
        printf("Neizdevaas inicializeet OpenGL\n");
        SDL_Quit();
        return -1;                                   
    }
    
    if(!Scene.LoadFiles()) //ielaadeejam sceenai nepiecieshamos failus
    {
        printf("Neizdevaas ielaadeet sceenai nepiecieshamos failus\n");
        SDL_Quit();
        return -1;                          
    }
    
    Timer.Initialize(); //inicializeejam taimeri
    
    if(!LVFont.LoadFont("lvfont.tga")) //ielaadeejam bitmap fontu ar latvieshu burtiem
    {
        printf("Neizdevaas ielaadeet fontu\n");
        SDL_Quit();
        return -1;                          
    }
        
    while(!Quit) //kameer nav jaaiziet no programmas
    {
        while(SDL_PollEvent(&Event)) //kameer SDL suuta mums kaadu zinju
        {
            switch(Event.type) //paskatamies kaada tipa
                {
                    case SDL_KEYDOWN: //nospiesta poga
                        {
                            Keys[Event.key.keysym.sym]=true;//atziimeejam noteikto pogu 
                            break;                          //kaa nospiestu
                        }
                    case SDL_KEYUP: //atlaista poga
                        {
                            Keys[Event.key.keysym.sym]=false;//atziimeejam noteikto pogu
                            break;                           //kaa nenospiestu
                        }  
                    case SDL_QUIT: //aiztaisiits SDL logs
                        {
                            Quit=true; //atziimeejam ka laiks iziet no programmas
                            break;         
                        }
                }
        }//kad SDL vairs zinja nesuuta, uzrendereejam un upeitojam vienu kadru
        
        if(Keys[SDLK_ESCAPE])// nospiests ESCAPE - 
        {
            Quit=true;       //atziimeejam, ka laiks iziet no programmas  
        }
        if(Keys[SDLK_1])     //ja nospiests 1
        {
            RenderMode=1;    //iesleedzam pirmo render modi - IMMEDIATE_BY_VALUE
        }
        if(Keys[SDLK_2])     //ja nospiests 2
        {
            RenderMode=2;    //iesleedzam otro render modi - IMMEDIATE_BY_POINTER
        }
        if(Keys[SDLK_3])     //ja nospiests 3
        {
            RenderMode=3;    //iesleedzam tresho render modi - VERTEX_ARRAY
        }
        if(Keys[SDLK_4])     //ja nospiests 4
        {
            RenderMode=4;    //iesleedzam ceturto render modi - DISPLAY_LIST 
        }
        DrawScene(); //ziimeejam sceenu
        SDL_GL_SwapBuffers(); //samainaam vietaam dubultos bufferus - to, uz kura tikko
        //ziimeejaam, liekam apskatei, bet to, kas tika raadiits lietotaajam, njemam ziimeeshanai  
    }//beidzas programmas galvenais cikls
    
    Scene.FreeMemory(); //atbriivojam visu
    LVFont.UnLoadFont();    //aiznjemto atminju
    
    printf("Izsleedzam SDL...\n");
    SDL_Quit();
    printf("Izejam no programmas...\n");    
    return 0;    
}
