#include "scene.h"
#include "timer.h"

int RenderMode=IMMEDIATE_VALUE; //default render mode - immediate by value
float TimeSinceStart=0.0f; //saakumaa kopsh saakuma ir pagaajushas.. hmm... 0 sekundes :)

CScene Scene; //mainiigais, kuraa glabaajas muusu sceena



bool CScene::LoadFiles() //ielaadeejam sceenai vajadziigos failus
{
    if(!DuckModel.LoadFromASCIIFile("duck.dat"))
    {
        printf("Neizdevaas ielaadeet piiliites modeli\n");
        return false;                                            
    }
    
    if(!UFOModel.LoadFromASCIIFile("UFO.dat"))
    {
        printf("Neizdevaas ielaadeet lidojoshaa skjiiviisha modeli\n");
        return false;                                            
    }
    
    if(!Terrain.LoadFrom24BitBMPHeightMap("height.bmp"))
    {
        printf("Neizdevaas ielaadeet zemes modeli\n");
        return false;                                            
    }
    
    if(!LoadTexture("duck.bmp",&DuckTexture))
    {
        printf("Neizdevaas ielaadeet piiliites textuuru\n");
        return false;                                                   
    }
    
    if(!LoadTexture("UFO.bmp",&UFOTexture))
    {
        printf("Neizdevaas ielaadeet lidojoshaa skjiiviisha textuuru\n");
        return false;                                                   
    }
    
    if(!LoadTexture("terrain.bmp",&TerrainTexture))
    {
        printf("Neizdevaas ielaadeet zemes textuuru\n");
        return false;                                                   
    }
    
    if(!SkyBox.LoadTextures())
    {
        printf("Neizdevaas ielaadeet debesis\n");
        return false;                                            
    }
    return true;   
}



bool CScene::FreeMemory() //atbriivojam visu sceenai izmantoto atminju
{
    DuckModel.Delete();
    UFOModel.Delete();
    Terrain.Delete();
    SkyBox.Delete();
    glDeleteTextures(1,&DuckTexture);
    glDeleteTextures(1,&UFOTexture);
    glDeleteTextures(1,&TerrainTexture);
    return false;
}



bool CScene::Draw() //ziimeejam visu 3d sceenu
{
    Timer.Update(); //updeitojam taimeri katra kadra saakumaa
    TimeSinceStart+=Timer.GetLastFrameTime(); //pieskaitam pie pagaajushaa laika skaitiitaaja
                           //pagaajushaa kadra laiku
    
    glMatrixMode(GL_PROJECTION); //panjemam projekcijas matricu
    glLoadIdentity(); //resetojam to
    gluPerspective(45.0f,ScreenWidth/ScreenHeight,1.0f,5000.0f); //uzstaadam muusu veelamo
                                                                //perspektiivu
    glMatrixMode(GL_MODELVIEW); //panjemam modelja matricu
    glLoadIdentity(); //resetojam to
    
    Camera.ApplyRotation(); //pareizinam to ar kameras rotaaciju matricaam
    SkyBox.Draw(); //ziimeejam debesim
    Camera.ApplyPosition(); //pareizinam modelja matricu ar kameras paarbiides matricu
    Camera.Controls(); //updeitojam kameras poziiciju un rotaaciju peec kontroljiem
    
    glEnable(GL_FOG); //iesleedzam miglu
    glFogi (GL_FOG_MODE, GL_EXP2); //izveelamies miglas modi EXP2
    
    float FogColor[4]={0.6f,0.6f,0.6f,1.0f}; //miglas kraasa
    
    glFogfv (GL_FOG_COLOR, FogColor); //noraadam miglas kraasu
    glFogf (GL_FOG_DENSITY, 0.001f); //noraadam miglas bliivumu
    glFogf (GL_FOG_START, 300.0f); //noraadam miglas saakumu
    glFogf (GL_FOG_END, 1000.0f); //un pilna bliivuma attalumu
    
    glBindTexture(GL_TEXTURE_2D,TerrainTexture); //izveelamies zemes textuuru
    Terrain.Draw(); //ziimejam zemi
    
    glBindTexture(GL_TEXTURE_2D,UFOTexture);//izveelamies UFO textuuru
    
    
    //viens vtis rots ap punktu (640.0f,300.0f,640.0f)
    //ar rdiusu 150 un trumu 90 grdi/sekund
    //un ap savu asi ar trumu 720 grdi/sekund
    glPushMatrix();
    glTranslatef(640.0f,300.0f,640.0f); //nobdam objektu uz punktu 640;300;640
    glRotatef(TimeSinceStart*90.0f,0.0f,1.0f,0.0f);  //pagrieam objektu (90 grdi sekund)
    glTranslatef(150.0f,0.0f,0.0f);  //nobdam objektu pa jau pagrieztajm asm 150 vienbas
    glRotatef(TimeSinceStart*720.0f,0.0f,1.0f,0.0f); //pagrieam objektu (720 grdi sekund)
    UFOModel.Draw(); //ziimejam UFO
    glPopMatrix();
    
    //otrs vtis rots ap punktu (640.0f,250.0f,640.0f)
    //ar rdiusu 150 un trumu 90 grdi/sekund
    //un ap savu asi ar trumu 720 grdi/sekund
    //bet bs 3 reiz lielks k pirmais
    glPushMatrix();
    glTranslatef(640.0f,250.0f,640.0f);
    glRotatef(TimeSinceStart*90.0f,0.0f,1.0f,0.0f);
    glTranslatef(-150.0f,0.0f,0.0f);
    glRotatef(TimeSinceStart*720.0f,0.0f,1.0f,0.0f);
    glScalef(3.0f,3.0f,3.0f);
    UFOModel.Draw(); //ziimejam UFO
    glPopMatrix();
    
    glBindTexture(GL_TEXTURE_2D,DuckTexture);//izveelamies piiliites textuuru
    
    //viena plte vienkri rots punkt (320.0f,200.0f,320.0f)
    glPushMatrix();
    glTranslatef(320.0f,200.0f,320.0f);
    glRotatef(TimeSinceStart*360.0f,1.0f,1.0f,1.0f);
    DuckModel.Draw();//ziimeejam piitliiti
    glPopMatrix();
    
    //otra plte vienkri rots punkt (960.0f,200.0f,960.0f)
    //un bs 4reiz lielka k pirm
    glPushMatrix();
    glTranslatef(960.0f,200.0f,960.0f);
    glRotatef(TimeSinceStart*360.0f,1.0f,1.0f,1.0f);
    glScalef(4.0f,4.0f,4.0f);
    DuckModel.Draw();//ziimeejam piitliiti
    glPopMatrix();
    
    //tlk uzzmsim "Saules sistmu", tikai ar pltm un lidojoiem viem :)
    glPushMatrix();
    glTranslatef(640.0f,500.0f,640.0f); //Saule jeb liel plte bs aj pozcij
        glPushMatrix();
        glRotatef(TimeSinceStart*45.0f,0.0f,1.0f,0.0f);//Saule griezsies ar 45deg/sec
        glScalef(20.0f,20.0f,20.0f); //20 reiu lielka, nek modelis
        glBindTexture(GL_TEXTURE_2D,DuckTexture);
        DuckModel.Draw();
        glPopMatrix();
        
        //ap sauli griezsies 3 "plantas" - vsi, ar dazdiem trumiem un radiusiem
        
        glPushMatrix();
        glRotatef(TimeSinceStart*60.0f,0.0f,1.0f,0.0f);//1.vtis rots ar 60deg/sec
        glTranslatef(230.0f,0.0f,0.0f); //un radiusu 230.0f
            glPushMatrix();
            glRotatef(TimeSinceStart*95.0f,0.0f,1.0f,0.0f);//ap savu centru ar ar 95deg/sec
            glScalef(6.0f,6.0f,6.0f); //6 reiu lielks, nek modelis
            glBindTexture(GL_TEXTURE_2D,UFOTexture);
            UFOModel.Draw();
            glPopMatrix();
            //ap pirmo vti rots 2 pltes
            glPushMatrix();
            glRotatef(TimeSinceStart*70.0f,0.0f,1.0f,0.0f);//pirm ar trumu 70deg/sec
            glTranslatef(80.0f,0.0f,0.0f); //rdiusu 80.0
            glRotatef(TimeSinceStart*180.0f,0.0f,1.0f,0.0f); //ap savu centru 180deg/sec
            glBindTexture(GL_TEXTURE_2D,DuckTexture);
            DuckModel.Draw();
            glPopMatrix();
            
            glPushMatrix();
            glRotatef(TimeSinceStart*140.0f,0.0f,1.0f,0.0f);//otr ar trumu 140deg/sec
            glTranslatef(100.0f,0.0f,0.0f); //rdiusu 100.0
            glRotatef(TimeSinceStart*270.0f,0.0f,1.0f,0.0f); //ap savu centru 270deg/sec
            glBindTexture(GL_TEXTURE_2D,DuckTexture);
            DuckModel.Draw();
            glPopMatrix();
        glPopMatrix();
        
        glPushMatrix();
        glRotatef(TimeSinceStart*120.0f,0.0f,1.0f,0.0f);//2.vtis rots ar 120deg/sec
        glTranslatef(430.0f,0.0f,0.0f); //un radiusu 430.0f
            glPushMatrix();
            glRotatef(TimeSinceStart*15.0f,0.0f,1.0f,0.0f);//ap savu centru ar ar 15deg/sec
            glScalef(5.0f,5.0f,5.0f); //5 reiu lielks, nek modelis
            glBindTexture(GL_TEXTURE_2D,UFOTexture);
            UFOModel.Draw();
            glPopMatrix();
            
            //ap otro vti rots 1 plte
            glPushMatrix();
            glRotatef(TimeSinceStart*170.0f,0.0f,1.0f,0.0f);//ar trumu 170deg/sec
            glTranslatef(100.0f,0.0f,0.0f); //rdiusu 100.0
            glRotatef(TimeSinceStart*9600.0f,0.0f,1.0f,0.0f); //ap savu centru 960deg/sec
            glBindTexture(GL_TEXTURE_2D,DuckTexture);
            DuckModel.Draw();
            glPopMatrix();
        glPopMatrix();
        
        glPushMatrix();
        glRotatef(TimeSinceStart*240.0f,0.0f,1.0f,0.0f);//4.vtis rots ar 240deg/sec
        glTranslatef(630.0f,0.0f,0.0f); //un radiusu 630.0f
        glRotatef(TimeSinceStart*1500.0f,0.0f,1.0f,0.0f);//ap savu centru ar ar 1500deg/sec
        glScalef(8.0f,8.0f,8.0f); //8 reiu lielks, nek modelis
        glBindTexture(GL_TEXTURE_2D,UFOTexture);
        UFOModel.Draw();
        glPopMatrix();
        
    glPopMatrix();
    
    glDisable(GL_FOG);//izsleedzam miglu
    
    return true;   
}
