#ifndef _SCENE_H_
#define _SCENE_H_

#include "model.h"
#include "texload.h"
#include "camera.h"
#include "skybox.h"
//identifikatori iespeejamajaam render modeem
#define IMMEDIATE_VALUE 1  
#define IMMEDIATE_POINTER 2
#define VERTEX_ARRAY 3
#define DISPLAY_LIST 4

extern int RenderMode; //tekoshaa render mode



class CScene //klasse, kuraa glabaajam info par muusu sceenu
{
    CModel DuckModel;
    GLuint DuckTexture;
    
    CModel UFOModel;
    GLuint UFOTexture;
    
    CModel Terrain;
    GLuint TerrainTexture;
    
    CCamera Camera;
    
    CSkyBox SkyBox;
public:
    bool LoadFiles(); //ielaadejam sceenai vaidziigos modlejus
    bool FreeMemory(); //atbriivojam atminju
    bool Draw(); //ziimeejam 3d sceenu
};


extern CScene Scene;

#endif
