#include "texload.h"

#include <strings.h>

//ielaadeejam TGA
//un atgriezjam rezultaatus parametros, ko padod kaa references
bool Load32BitTGA(char *FileName,int &Width,int &Height,unsigned char* &Data)
{
    FILE* fp=fopen(FileName,"rb");
    if(!fp)
    {
        printf("Nevaru ielaadeet 32 bitu tga failu %s - nav taada faila\n",FileName);
        return false;
    }

    unsigned char Text,c,ColorMap,CMapEntSize,BPP;
    unsigned short ColCount;
    unsigned t;

    fread(&Text,1,1,fp); //nolasam info txt, kas buus veelaak failaa, garumu
    fread(&ColorMap,1,1,fp); //nolasam vai buus kraasu palete (0=nee)
    fread(&c,1,1,fp);//nolasam faila kompresijas tipu - mees pienjemsim tikai nekompreseetas (veertiiba 2)
    if(c!=2)
    {
        printf("Nevaru ielaadeet 32 bitu tga failu %s - fails nav nekompreseeta targa\n",FileName);
        fclose(fp);
        return false;
    }
    fseek(fp,2,SEEK_CUR);//izlaizjam divus nesvariigus baitus

    fread(&ColCount,1,2,fp); //nolasam kraasu paletes garumu
    fread(&CMapEntSize,1,1,fp); //nolasam viena paletes elementa garumu bito
    CMapEntSize/=8;//paarveersham baitos

    fseek(fp,4,SEEK_CUR);//izlaizjam chetrus nesvariigus baitus
    Width=0; Height=0;
    fread(&Width,1,2,fp);//nolasam bildes platumu
    fread(&Height,1,2,fp);//nolasam bidles garumu
    fread(&BPP,1,1,fp);//nolasam bitus uz pixeli
    if(BPP!=32) //ja nav 32bit
    {
        printf("Nevaru ielaadeet 32 bitu tga failu %s - taa nav 32 bitu targa\n",FileName);
        fclose(fp);
        return false;   
    }    

    fseek(fp,Text+1,SEEK_CUR);//izlaizjam nesvariigu info txt

    if(ColorMap)//ja ir kraasu palete
    fseek(fp,ColCount*CMapEntSize,SEEK_CUR);//izlaizjam paleti

    Data=new unsigned char[4*Width*Height];//atbriivojam vietu bildes kraasu masiivam
    unsigned Size=Height*Width;

    for(t=0;t<Size;t++)//noslasam bildi GBRA formaataa no 
    {//faila un saglabaajam RGBA formaataa prieksh OpenGL
        fread(&Data[t*4+2],1,1,fp);
        fread(&Data[t*4+1],1,1,fp);
        fread(&Data[t*4],1,1,fp);
        fread(&Data[t*4+3],1,1,fp);
    }

    fclose(fp);
    return true;    
}    


//ielaadeejam BMP
//un atgriezjam rezultaatus parametros, ko padod kaa references
bool Load24BitBMP(char *FileName,int &Width,int &Height,unsigned char* &Data)
{
    FILE* fp=fopen(FileName,"rb");
    if(!fp)
    {
        printf("Nevaru ielaadeet 24 bitu bmp failu %s - nav taada faila\n",FileName);
        return false;
    }

    char c;
    unsigned k,Offset;
    unsigned short Colors;

    fread(&c,1,1,fp);//nolasam pirmo faila baitu, BMP failaa tam jaabuut B
    if(c!='B')
    {
        printf("Nevaru ielaadeet 24 bitu bmp failu %s - tas nav bmp fails\n",FileName);
        fclose(fp);
        return false;
    }
    fread(&c,1,1,fp);//nolasam otro faila baitu, BMP failaa tam jaabuut M
    if(c!='M')
    {
        printf("Nevaru ielaadeet 24 bitu bmp failu %s - tas nav bmp fails\n",FileName);
        fclose(fp);
        return false;
    }
    
    fseek(fp,8,SEEK_CUR);//izlaizjam 8 liekus baitus
    fread(&Offset,1,4,fp);//nolasam cik baitus no faila saakuma atroda bildes dati
    fseek(fp,4,SEEK_CUR);//izlaizjam 4 liekus baitus
    fread(&Width,1,4,fp);//nolasam bildes platumu
    fread(&Height,1,4,fp);//nolasam bildes garumu
    fseek(fp,2,SEEK_CUR);//izlaizjam 2 liekus baitus
    fread(&Colors,1,2,fp);//nolasam bitus uz pixeli
    fclose(fp);//aiztaisam failu
    if(Colors!=24)// ja nav 24bit
    {
        printf("Nevaru ielaadeet 24 bitu bmp failu %s - tas nav 24 bitu bmp fails\n",FileName);
        return false;
    }
    
    fp=fopen(FileName,"rb");//atveram failu pa jaunam
    if(!fp)
    {
        printf("Nevaru ielaadeet 24 bitu bmp failu %s - taada faila nav\n",FileName);
        return false;
    }
    
    fseek(fp,Offset,SEEK_CUR);//paarlecam uzreiz uz kraasu masiiva saakumu

    Data=new unsigned char[Width*Height*3]; //atbriivojam vietu textuurai atminjaa
    unsigned Size=Width*Height;
    for(k=0;k<Size;k++)//nolasaam textuuru no GBR faila un saglanbaajam kaa RGB atminjaa
    {                                                        //prieksh OpenGL
        fread(&Data[3*k+2],1,1,fp);
        fread(&Data[3*k+1],1,1,fp);
        fread(&Data[3*k],1,1,fp);
    }

    fclose(fp);
     
    return true;
}


//ielaadeejam textuuru no noraadiitaa faila
//un saglabaajam textuuraa, uz ko padots pointers
bool LoadTexture(char *FileName,GLuint *Texture)
{
    int Width,Height,Type;
    unsigned char *Data=NULL;
    
    int len=strlen(FileName);
    if(!strcmp(&FileName[len-4],".bmp"))// ja faila tips ir .bmp
    {
        Type=3;
        if(!Load24BitBMP(FileName,Width,Height,Data))//ielaadeejam 24 bitu BMP
            return false;        
    } else if(!strcmp(&FileName[len-4],".tga"))//ja faila tips ir .tga
    {
        Type=4;
        if(!Load32BitTGA(FileName,Width,Height,Data))//ielaadeejam 32 bitu TGA
            return false;          
    } else {//ja ne is, ne tas - 
        printf("Nevaru ielaadeet textuuru %s, nezinaams faila tips",FileName);
        return false;  
    }         
    

     
    glGenTextures(1, Texture);//dabuunam jaunu textuuras ID
    glBindTexture(GL_TEXTURE_2D, *Texture);//piebaindojam jauno textuuru
    
    //visas textuuras ielaadeejam kaa mipmapus
    if(Type==3)
        gluBuild2DMipmaps(GL_TEXTURE_2D, 3, Width, Height, GL_RGB, GL_UNSIGNED_BYTE, Data);
    if(Type==4)
        gluBuild2DMipmaps(GL_TEXTURE_2D, 4, Width, Height, GL_RGBA, GL_UNSIGNED_BYTE, Data);
    
    //un peec defaulta uzstaadas trilineaaro filtraaciju
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR_MIPMAP_LINEAR);
    glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR_MIPMAP_LINEAR);
    
    //un GL_REPEAT kaa wrap setingus gan S gan T 
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
    
    if(Data)
        delete[] Data;// nodsham textuuras datus, jo nu tie jau ir video kartee
    
    return true;
}
